// FormatMessageDlg.cpp : t@C
//

#include "stdafx.h"
#include "util.h"
#include "FormatMessage.h"
#include "FormatMessageDlg.h"
#include <algorithm>
using namespace Util;


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CFormatMessageDlg _CAO

static LVCOLUMN s_cols[] =
{
	{ LVCF_FMT | LVCF_TEXT | LVCF_WIDTH, LVCFMT_LEFT, 100, TEXT("ErrorCode")		},
	{ LVCF_FMT | LVCF_TEXT | LVCF_WIDTH, LVCFMT_LEFT, 400, TEXT("FormatMessage")	},
};

CFormatMessageDlg::CFormatMessageDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFormatMessageDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	std::fill(m_bSortAsend, m_bSortAsend+ARRAYSIZE(m_bSortAsend), FALSE);
}

BOOL CFormatMessageDlg::PreTranslateMessage(MSG* pMsg)
{
	// TODO : ɓȃR[hǉ邩A͊{NXĂяoĂB
	if(pMsg->message == WM_KEYDOWN)
	{
		if(pMsg->wParam == VK_RETURN)
		{
			if (pMsg->hwnd == GetDlgItem(IDC_EDIT1)->GetSafeHwnd() ||
				pMsg->hwnd == GetDlgItem(IDC_EDIT2)->GetSafeHwnd())
			{
				SendMessage(WM_COMMAND, IDC_BUTTON1);
				((CEdit*)CWnd::FromHandle(pMsg->hwnd))->SetSel(0, -1);
				return TRUE;
			}
		}
		if(pMsg->wParam == VK_F5)
		{
			SendMessage(WM_COMMAND, IDC_BUTTON1);
			return TRUE;
		}
	}

	return CDialog::PreTranslateMessage(pMsg);
}

void CFormatMessageDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT1, theApp.m_setting.m_dwErrCodeFrom);
	DDX_Text(pDX, IDC_EDIT2, theApp.m_setting.m_dwErrCodeTo);
	DDX_Control(pDX, IDC_LIST1, m_wndErrList);
}

BEGIN_MESSAGE_MAP(CFormatMessageDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnBnClickedButton3)
	ON_COMMAND(ID_ERRLIST_COPY, OnErrListCopy)
	ON_NOTIFY(NM_RCLICK, IDC_LIST1, OnNMRclickList1)
	ON_NOTIFY(LVN_GETDISPINFO, IDC_LIST1, OnLvnGetdispinfoList1)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_LIST1, OnLvnColumnclickList1)
END_MESSAGE_MAP()


// CFormatMessageDlg bZ[W nh

BOOL CFormatMessageDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B
	UpdateData(FALSE);
	m_wndErrList.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_LABELTIP);
	for(int i = 0; i < ARRAYSIZE(s_cols); ++i)
	{
		m_wndErrList.InsertColumn(i, s_cols+i);
	}
	SendMessage(WM_COMMAND, IDC_BUTTON1);
	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CFormatMessageDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CFormatMessageDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//[U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CFormatMessageDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CFormatMessageDlg::OnBnClickedButton1()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	CWaitCursor	wait;
	UpdateData();
	m_wndErrList.SetRedraw(FALSE);
	m_wndErrList.DeleteAllItems();
	LVITEM	item = { LVIF_TEXT | LVIF_PARAM };
	DWORD	dwErrCodeFrom = theApp.m_setting.m_dwErrCodeFrom;
	DWORD	dwErrCodeTo = theApp.m_setting.m_dwErrCodeTo;
	for(DWORD dw = dwErrCodeFrom; dw <= dwErrCodeTo; ++dw)
	{
		item.pszText = LPSTR_TEXTCALLBACK;
		item.lParam = dw;
		m_wndErrList.InsertItem(&item);
		++item.iItem;
	}
	m_wndErrList.SetRedraw(TRUE);
}

void CFormatMessageDlg::OnBnClickedButton2()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	DllListDlg(this, theApp.m_setting.m_strDlls);
}

void CFormatMessageDlg::OnBnClickedButton3()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	MsgDlgParam	mdp = { m_wndErrList.GetSafeHwnd(), theApp.m_setting.m_strFindMsg, theApp.m_setting.m_nSearch };
	if(MsgSearchDlg(this, mdp))
	{
		theApp.m_setting.m_strFindMsg = mdp.strMsg;
		theApp.m_setting.m_nSearch = mdp.nSearch;
	}
}

void CFormatMessageDlg::OnLvnGetdispinfoList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	NMLVDISPINFO *pDispInfo = reinterpret_cast<NMLVDISPINFO*>(pNMHDR);
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	DWORD	dwMsg = static_cast<DWORD>(pDispInfo->item.lParam);
	if(pDispInfo->item.mask & LVIF_TEXT)
	{
		switch(pDispInfo->item.iSubItem)
		{
		case 0:
			wnsprintf(pDispInfo->item.pszText, pDispInfo->item.cchTextMax, TEXT("%d(0x%x)"), dwMsg, dwMsg);
			break;
		case 1:
			{
				CHeapPtr<TCHAR, CLocalAllocator>	pMsg;
				if(! FindFormatMessage(dwMsg, theApp.m_setting.m_strDlls, &pMsg))
				{
					LoadString(AfxGetResourceHandle(), IDS_MSGNOTFOUND, pDispInfo->item.pszText, pDispInfo->item.cchTextMax);
				}
				else
				{
					StrRemove(pMsg, TEXT("\r\n"));
					lstrcpyn(pDispInfo->item.pszText, pMsg, pDispInfo->item.cchTextMax);
				}
			}
			break;
		}
	}
	pDispInfo->item.mask |= LVIF_DI_SETITEM;
	*pResult = 0;
}

void CFormatMessageDlg::OnErrListCopy()
{
	POSITION	pos = m_wndErrList.GetFirstSelectedItemPosition();
	if(NULL == pos)
	{
		return;
	}
	DWORD	dwErrCode = static_cast<DWORD>(m_wndErrList.GetItemData(m_wndErrList.GetNextSelectedItem(pos)));
	CHeapPtr<TCHAR, CLocalAllocator>	pMsg;
	if(FindFormatMessage(dwErrCode, theApp.m_setting.m_strDlls, &pMsg))
	{
		SetClipboardText(GetSafeHwnd(), pMsg);
	}
}

void CFormatMessageDlg::OnNMRclickList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	LPNMITEMACTIVATE	pnm = (LPNMITEMACTIVATE)pNMHDR;
	if(pnm->iItem >= 0)
	{
		POINT	pt = pnm->ptAction;
		m_wndErrList.ClientToScreen(&pt);
		CMenu	menu;
		menu.LoadMenu(IDR_MENU);
		CMenu*	pSub = menu.GetSubMenu(0);
		if(pSub)
		{
			pSub->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x, pt.y, this);
		}
	}
	*pResult = 0;
}

static int CALLBACK _CompareErrCode(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	return (static_cast<DWORD>(lParam1)-static_cast<DWORD>(lParam2));
}

static int CALLBACK _CompareMessage(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	CHeapPtr<TCHAR, CLocalAllocator>	pMsg1, pMsg2;
	FindFormatMessage(static_cast<DWORD>(lParam1), theApp.m_setting.m_strDlls, &pMsg1);
	FindFormatMessage(static_cast<DWORD>(lParam2), theApp.m_setting.m_strDlls, &pMsg2);
	return lstrcmp(pMsg1, pMsg2);
}

void CFormatMessageDlg::OnLvnColumnclickList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	CWaitCursor	wait;
	switch(pNMLV->iSubItem)
	{
	case 0:
		{
			LVItemCompare	comp(_CompareErrCode, m_bSortAsend[0] = ! m_bSortAsend[0]);
			m_wndErrList.SortItems(LVItemCompare::ComparePrimary, reinterpret_cast<DWORD_PTR>(&comp));
		}
		break;
	case 1:
		{
			LVItemCompare	comp(_CompareMessage, m_bSortAsend[1] = ! m_bSortAsend[1], reinterpret_cast<LPARAM>(&m_wndErrList));
			m_wndErrList.SortItems(LVItemCompare::ComparePrimary, reinterpret_cast<DWORD_PTR>(&comp));
		}
		break;
	}
	*pResult = 0;
}


