// MsgSearchDlg.cpp : t@C
//

#include "stdafx.h"
#include "FormatMessage.h"
#include "util.h"
#include "MsgSearchDlg.h"
using namespace Util;


// CMsgSearchDlg _CAO

IMPLEMENT_DYNAMIC(CMsgSearchDlg, CDialog)
CMsgSearchDlg::CMsgSearchDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMsgSearchDlg::IDD, pParent)
	, m_nSearch(SEARCH_DOWN)
	, m_strMsg(_T(""))
	, m_bDoSearch(FALSE)
{
}

CMsgSearchDlg::~CMsgSearchDlg()
{
}

void CMsgSearchDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT1, m_wndMsg);
	DDX_Text(pDX, IDC_EDIT1, m_strMsg);
	DDX_Radio(pDX, IDC_RADIO1, m_nSearch);
}


BEGIN_MESSAGE_MAP(CMsgSearchDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_EN_CHANGE(IDC_EDIT1, OnEnChangeEdit1)
	ON_WM_CTLCOLOR()
END_MESSAGE_MAP()


// CMsgSearchDlg bZ[W nh

BOOL CMsgSearchDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO :  ɏǉĂ
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

void CMsgSearchDlg::OnBnClickedButton1()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	SetDlgItemText(IDC_STATIC_SEARCHED, TEXT(""));
	UpdateData();
	if(m_strMsg.IsEmpty())
	{
		return;
	}
	m_bDoSearch = TRUE;
	CWaitCursor	wait;
	CListCtrl*	pList = (CListCtrl*)CWnd::FromHandle(m_hwndErrList);
	int		iItem = pList->GetNextItem(-1, LVNI_SELECTED | LVNI_ALL);
	if(iItem < 0)
	{
		iItem = (m_nSearch == SEARCH_UP ? pList->GetItemCount()-1 : 0);
	}
	else
	{
		iItem = _MoveCursor(iItem);
	}
	for(; iItem >= 0; iItem = _MoveCursor(iItem))
	{
		DWORD	dwMsg = (DWORD)pList->GetItemData(iItem);
		CHeapPtr<TCHAR, CLocalAllocator>	pMsg;
		if(FindFormatMessage(dwMsg, theApp.m_setting.m_strDlls, &pMsg))
		{
			if(_tcsstr(pMsg, m_strMsg))
			{
				pList->SetItemState(iItem, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
				pList->EnsureVisible(iItem, FALSE);
				break;
			}
		}
	}
	if(iItem < 0)
	{
		CString	strSearched;
		strSearched.LoadString(IDS_SEARCHED);
		SetDlgItemText(IDC_STATIC_SEARCHED, strSearched);		
	}
}

void CMsgSearchDlg::OnEnChangeEdit1()
{
	// TODO :  ꂪ RICHEDIT Rg[̏ꍇA܂ACDialog::OnInitDialog() ֐I[o[ChāA
	// OR Ԃ ENM_CORRECTTEXT tO}XNɓāA
	// CRichEditCtrl().SetEventMask() ĂяoȂA
	// Rg[́A̒ʒm𑗐M܂B

	// TODO :  ɃRg[ʒmnh R[hǉĂB
	GetDlgItem(IDC_BUTTON1)->EnableWindow(m_wndMsg.GetWindowTextLength() > 0);
}

int CMsgSearchDlg::_MoveCursor(int iFrom)
{
	CListCtrl*	pList = (CListCtrl*)CWnd::FromHandle(m_hwndErrList);
	return pList->GetNextItem(iFrom, (m_nSearch == SEARCH_UP ? LVNI_ABOVE : LVNI_BELOW));
}


HBRUSH CMsgSearchDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	// TODO :   DC ̑ύXĂB
	if(IDC_STATIC_SEARCHED == pWnd->GetDlgCtrlID() && pWnd->GetWindowTextLength())
	{
		pDC->SetTextColor(GetSysColor(COLOR_HIGHLIGHTTEXT));
		pDC->SetBkColor(GetSysColor(COLOR_HIGHLIGHT));
		return GetSysColorBrush(COLOR_HIGHLIGHT);
	}

	// TODO :  lgpȂꍇ͕ʂ̃uVԂ܂B
	return hbr;
}
